searchNodes=[{"doc":"Represents the arguments to a calculation being filtered on","ref":"AshPhoenix.FilterForm.Arguments.html","title":"AshPhoenix.FilterForm.Arguments","type":"module"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#errors/2","title":"AshPhoenix.FilterForm.Arguments.errors/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#new/2","title":"AshPhoenix.FilterForm.Arguments.new/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#validate_arguments/2","title":"AshPhoenix.FilterForm.Arguments.validate_arguments/2","type":"function"},{"doc":"Create a new filter form. Options: :params ( term/0 ) - Initial parameters to create the form with The default value is %{} . :as ( String.t/0 ) - Set the parameter name for the form. The default value is &quot;filter&quot; . :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the predicate and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :remove_empty_groups? ( boolean/0 ) - If true (the default), then any time a group would be made empty by removing a group or predicate, it is removed instead. An empty form can still be added, this only affects a group if its last component is removed. The default value is false .","ref":"AshPhoenix.FilterForm.html","title":"AshPhoenix.FilterForm","type":"module"},{"doc":"Adde a group to the filter. Options: :to ( String.t/0 ) - The nested group id to add the group to. :operator - The operator that the group should have internally. The default value is :and . :return_id? ( boolean/0 ) - If set to true , the function returns {form, predicate_id} The default value is false .","ref":"AshPhoenix.FilterForm.html#add_group/2","title":"AshPhoenix.FilterForm.add_group/2","type":"function"},{"doc":"Add a predicate to the filter. Options: :to ( String.t/0 ) - The group id to add the predicate to. If not set, will be added to the top level group. :return_id? ( boolean/0 ) - If set to true , the function returns {form, predicate_id} The default value is false . :path - The relationship path to apply the predicate to","ref":"AshPhoenix.FilterForm.html#add_predicate/5","title":"AshPhoenix.FilterForm.add_predicate/5","type":"function"},{"doc":"Returns a flat list of all errors on all predicates in the filter.","ref":"AshPhoenix.FilterForm.html#errors/2","title":"AshPhoenix.FilterForm.errors/2","type":"function"},{"doc":"Returns the list of available fields, which may be attributes, calculations, or aggregates.","ref":"AshPhoenix.FilterForm.html#fields/1","title":"AshPhoenix.FilterForm.fields/1","type":"function"},{"doc":"Same as filter/2 but raises on errors.","ref":"AshPhoenix.FilterForm.html#filter!/2","title":"AshPhoenix.FilterForm.filter!/2","type":"function"},{"doc":"Converts the form into a filter, and filters the provided query or resource with that filter.","ref":"AshPhoenix.FilterForm.html#filter/2","title":"AshPhoenix.FilterForm.filter/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.html#new/2","title":"AshPhoenix.FilterForm.new/2","type":"function"},{"doc":"Returns the minimal set of params (at the moment just strips ids) for use in a query string.","ref":"AshPhoenix.FilterForm.html#params_for_query/1","title":"AshPhoenix.FilterForm.params_for_query/1","type":"function"},{"doc":"Returns the list of available predicates for the given resource, which may be functions or operators.","ref":"AshPhoenix.FilterForm.html#predicates/1","title":"AshPhoenix.FilterForm.predicates/1","type":"function"},{"doc":"Removes the group or component with the given id","ref":"AshPhoenix.FilterForm.html#remove_component/2","title":"AshPhoenix.FilterForm.remove_component/2","type":"function"},{"doc":"Remove the group with the given id","ref":"AshPhoenix.FilterForm.html#remove_group/2","title":"AshPhoenix.FilterForm.remove_group/2","type":"function"},{"doc":"Remove the predicate with the given id","ref":"AshPhoenix.FilterForm.html#remove_predicate/2","title":"AshPhoenix.FilterForm.remove_predicate/2","type":"function"},{"doc":"Same as to_filter/1","ref":"AshPhoenix.FilterForm.html#to_filter!/1","title":"AshPhoenix.FilterForm.to_filter!/1","type":"function"},{"doc":"Returns a filter expression that can be provided to Ash.Query.filter/2 To add this to a query, remember to use ^ , for example: filter = AshPhoenix.FilterForm . to_filter_expression ( form ) Ash.Query . filter ( MyApp.Post , ^ filter ) Alternatively, you can use the shorthand: filter/2 to apply the expression directly to a query.","ref":"AshPhoenix.FilterForm.html#to_filter_expression/1","title":"AshPhoenix.FilterForm.to_filter_expression/1","type":"function"},{"doc":"Returns a filter map that can be provided to Ash.Filter.parse This allows for things like saving a stored filter. Does not currently support parameterizing calculations or functions.","ref":"AshPhoenix.FilterForm.html#to_filter_map/1","title":"AshPhoenix.FilterForm.to_filter_map/1","type":"function"},{"doc":"Update the predicate with the given id","ref":"AshPhoenix.FilterForm.html#update_predicate/3","title":"AshPhoenix.FilterForm.update_predicate/3","type":"function"},{"doc":"Updates the filter with the provided input and validates it. At present, no validation actually occurs, but this will eventually be added.","ref":"AshPhoenix.FilterForm.html#validate/2","title":"AshPhoenix.FilterForm.validate/2","type":"function"},{"doc":"Represents an individual predicate appearing in a filter form. Predicates are grouped up in an AshPhoenix.FilterForm to create boolean filter statements.","ref":"AshPhoenix.FilterForm.Predicate.html","title":"AshPhoenix.FilterForm.Predicate","type":"module"},{"doc":"","ref":"AshPhoenix.FilterForm.Predicate.html#errors/2","title":"AshPhoenix.FilterForm.Predicate.errors/2","type":"function"},{"doc":"A module to allow you to fluidly use resources with phoenix forms. Life cycle The general workflow is, with either liveview or phoenix forms: Create a form with AshPhoenix.Form Render that form with Phoenix's form_for (or, if using surface, &lt;Form&gt;) To validate the form (e.g with on-change for liveview), pass the input to AshPhoenix.Form.validate(form, params) On form submission, pass the input to AshPhoenix.Form.validate(form, params) and then use AshPhoenix.Form.submit(form) On success, use the result to redirect or assign. On failure, reassign the provided form. The following keys exist on the form to show where in the lifecycle you are: submitted_once? - If the form has ever been submitted. Useful for not showing any errors on the first attempt to fill out a form. just_submitted? - If the form has just been submitted and no validation has happened since. Useful for things like triggering a UI effect that should stop when the form is modified again. .changed? - If something about the form is different than it originally was. Note that in some cases this can yield a false positive, specifically if a nested form is removed and then a new one is added with the exact same values. .touched_forms - A MapSet containing all keys in the form that have been modified. When submitting a form, only these keys are included in the parameters. Working with related data If your resource action accepts related data, (for example a managed relationship argument, or an embedded resource attribute), you can use Phoenix's inputs_for for that field, but you must do one of two things: Tell AshPhoenix.Form to automatically derive this behavior from your action, for example: form = user |&gt; AshPhoenix.Form . for_update ( :update , api : MyApi , forms : [ auto? : true ] ] ) Explicitly configure the behavior of it using the forms option. See for_create/3 for more. For example: form = user |&gt; AshPhoenix.Form . for_update ( :update , api : MyApi , forms : [ profile : [ resource : MyApp.Profile , data : user . profile , create_action : :create , update_action : :update forms : [ emails : [ data : user . profile . emails , resource : MyApp.UserEmail , create_action : :create , update_action : :update ] ] ] ] ) LiveView AshPhoenix.Form (unlike ecto changeset based forms) expects to be reused throughout the lifecycle of the liveview. You can use phoenix events to add and remove form entries and submit/2 to submit the form, like so: alias MyApp.MyApi . { Comment , Post } def render ( assigns ) do ~L&quot;&quot;&quot; &lt;%= f = form_for @form, &quot;#&quot;, [phx_change: :validate, phx_submit: :save] %&gt; &lt;%= label f, :text %&gt; &lt;%= text_input f, :text %&gt; &lt;%= error_tag f, :text %&gt; &lt;%= for comment_form &lt;- inputs_for(f, :comments) do %&gt; &lt;%= hidden_inputs_for(comment_form) %&gt; &lt;%= text_input comment_form, :text %&gt; &lt;%= for sub_comment_form &lt;- inputs_for(comment_form, :sub_comments) do %&gt; &lt;%= hidden_inputs_for(sub_comment_form) %&gt; &lt;%= text_input sub_comment_form, :text %&gt; &lt;button phx-click=&quot;remove_form&quot; phx-value-path=&quot;&lt;%= sub_comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;% end %&gt; &lt;button phx-click=&quot;remove_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;button phx-click=&quot;add_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;% end %&gt; &lt;button phx-click=&quot;add_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;%= submit &quot;Save&quot; %&gt; &lt;/form&gt; &quot;&quot;&quot; end def mount ( %{ &quot;post_id&quot; =&gt; post_id } , _session , socket ) do post = Post |&gt; MyApp.MyApi . get! ( post_id ) |&gt; MyApi . load! ( comments : [ :sub_comments ] ) form = AshPhoenix.Form . for_update ( post , api : MyApp.MyApi , forms : [ comments : [ resource : Comment , data : post . comments , create_action : :create , update_action : :update forms : [ sub_comments : [ resource : Comment , data : &amp; ( &amp;1 . sub_comments ) , create_action : :create , update_action : :update ] ] ] ] ) { :ok , assign ( socket , form : form ) } end # In order to use the `add_form` and `remove_form` helpers, you # need to make sure that you are validating the form on change def handle_event ( &quot;validate&quot; , %{ &quot;form&quot; =&gt; params } , socket ) do form = AshPhoenix.Form . validate ( socket . assigns . form , params ) # You can also skip errors by setting `errors: false` if you only want to show errors on submit # form = AshPhoenix.Form.validate(socket.assigns.form, params, errors: false) { :ok , assign ( socket , :form , form ) } end def handle_event ( &quot;save&quot; , _params , socket ) do case AshPhoenix.Form . submit ( socket . assigns . form ) do { :ok , result } -&gt; # Do something with the result, like redirect { :error , form } -&gt; assign ( socket , :form , form ) end end def handle_event ( &quot;add_form&quot; , %{ &quot;path&quot; =&gt; path } , socket ) do form = AshPhoenix.Form . add_form ( socket . assigns . form , path ) { :noreply , assign ( socket , :form , form ) } end def handle_event ( &quot;remove_form&quot; , %{ &quot;path&quot; =&gt; path } ) do form = AshPhoenix.Form . remove_form ( socket . assigns . form , path ) { :noreply , assign ( socket , :form , form ) } end","ref":"AshPhoenix.Form.html","title":"AshPhoenix.Form","type":"module"},{"doc":"Adds a new form at the provided path. Doing this requires that the form has a create_action and a resource configured. path can be one of two things: A list of atoms and integers that lead to a form in the forms option provided. [:posts, 0, :comments] to add a comment to the first post. The html name of the form, e.g form[posts][0][comments] to mimic the above If you pass parameters to this function, keep in mind that, unless they are string keyed in the same shape they might come from your form, then the result of params/1 will reflect that, i.e add_form(form, &quot;foo&quot;, %{bar: 10}) , could produce params like %{&quot;field&quot; =&gt; value, &quot;foo&quot; =&gt; [%{bar: 10}]} &quot;}. Notice how they are not string keyed as you would expect. However, once the form is changed (in liveview) and a call to validate/2 is made with that input, then the parameters would become what you'd expect. In this way, if you are using add_form with not string keys/values you may not be able to depend on the shape of the params map (which you should ideally not depend on anyway). :prepend ( boolean/0 ) - If specified, the form is placed at the beginning of the list instead of the end of the list The default value is false . :params ( term/0 ) - The initial parameters to add the form with. The default value is %{} . :validate? ( boolean/0 ) - Validates the new full form. The default value is true . :validate_opts ( term/0 ) - Options to pass to validate . Only used if validate? is set to true (the default) The default value is [] . :type - If type is set to :read , the form will be created for a read action. A hidden field will be set in the form called _form_type to track this information. The default value is :create . :data ( term/0 ) - The data to set backing the form. Generally you'd only want to do this if you are adding a form with type: :read additionally.","ref":"AshPhoenix.Form.html#add_form/3","title":"AshPhoenix.Form.add_form/3","type":"function"},{"doc":"A utility to get the list of arguments the action underlying the form accepts","ref":"AshPhoenix.Form.html#arguments/1","title":"AshPhoenix.Form.arguments/1","type":"function"},{"doc":"A utility to get the list of attributes the action underlying the form accepts","ref":"AshPhoenix.Form.html#attributes/1","title":"AshPhoenix.Form.attributes/1","type":"function"},{"doc":"Clears a given input's value on a form. Accepts a field (atom) or a list of fields (atoms) as a second argument.","ref":"AshPhoenix.Form.html#clear_value/2","title":"AshPhoenix.Form.clear_value/2","type":"function"},{"doc":"Returns the errors on the form. By default, only errors on the form being passed in (not nested forms) are provided. Use for_path to get errors for nested forms. :format - Values: - ` :raw ` - ` [ field : , { message , substitutions } } ] ` ( for translation ) - ` :simple ` - ` [ field : &quot;message w/ variables substituted&quot; ] ` - ` :plaintext ` - ` [ &quot;field: message w/ variables substituted&quot; ] ` The default value is ` :simple ` . :for_path ( term/0 ) - The path of the form you want errors for, either as a list or as a string, e.g [:comments, 0] or form[comments][0] Passing :all will cause this function to return a map of path to its errors, like so: %{[:comments, 0] =&gt; [body: &quot;is invalid&quot;], ...} The default value is [] .","ref":"AshPhoenix.Form.html#errors/2","title":"AshPhoenix.Form.errors/2","type":"function"},{"doc":"Calls the corresponding for_* function depending on the action type","ref":"AshPhoenix.Form.html#for_action/3","title":"AshPhoenix.Form.for_action/3","type":"function"},{"doc":"Creates a form corresponding to a create action on a resource. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. Any additional options will be passed to the underlying call to Ash.Changeset.for_create/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called. Nested Form Options To automatically determine the nested forms available for a given form, use forms: [auto?: true] . You can add additional nested forms by including them in the forms config alongside auto?: true . See the module documentation of AshPhoenix.Form.Auto for more information. If you want to do some manipulation of the auto forms, you can also call AshPhoenix.Form.Auto.auto/2 , and then manipulate the result and pass it to the forms option. :type - The cardinality of the nested form. The default value is :single . :sparse? ( boolean/0 ) - If the nested form is sparse , the form won't expect all inputs for all forms to be present. Has no effect if the type is :single . Normally, if you leave some forms out of a list of nested forms, they are removed from the parameters passed to the action. For example, if you had a post with two comments [%Comment{id: 1}, %Comment{id: 2}] and you passed down params like comments[0][id]=1&amp;comments[1][text]=new_text , we would remove the second comment from the input parameters, resulting in the following being passed into the action: %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}]} . By setting it to sparse, you have to explicitly use remove_form for that removal to happen. So in the same scenario above, the parameters that would be sent would actually be %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}, %{&quot;id&quot; =&gt; 2}]} . One major difference with sparse? is that the form actually ignores the index provided, e.g comments[0]... , and instead uses the primary key e.g comments[0][id] to match which form is being updated. This prevents you from having to find the index of the specific item you want to update. Which could be very gnarly on deeply nested forms. If there is no primary key, or the primary key does not match anything, it is treated as a new form. REMEMBER: You need to use hidden_inputs_for (or HiddenInputs if using surface) for the id to be automatically placed into the form. :forms ( keyword/0 ) - Forms nested inside the current nesting level in all cases :for_type - What action types the form applies for. Leave blank for it to apply to all action types. :merge? ( boolean/0 ) - When building parameters, this input will be merged with its parent input. This allows for combining multiple forms into a single input. The default value is false . :for ( atom/0 ) - When creating parameters for the action, the key that the forms should be gathered into. Defaults to the key used to configure the nested form. Ignored if merge? is true . :resource ( atom/0 ) - The resource of the nested forms. Unnecessary if you are providing the data key, and not adding additional forms to this path. :create_action ( atom/0 ) - The create action to use when building new forms. Only necessary if you want to use add_form/3 with this path. :update_action ( atom/0 ) - The update action to use when building forms for data. Only necessary if you supply the data key. :data ( term/0 ) - The current value or values that should have update forms built by default. You can also provide a single argument function that will return the data based on the data of the parent form. This is important for multiple nesting levels of :list type forms, because the data depends on which parent is being rendered.","ref":"AshPhoenix.Form.html#for_create/3","title":"AshPhoenix.Form.for_create/3","type":"function"},{"doc":"Creates a form corresponding to a destroy action on a record. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. Any additional options will be passed to the underlying call to Ash.Changeset.for_destroy/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_destroy/3","title":"AshPhoenix.Form.for_destroy/3","type":"function"},{"doc":"Creates a form corresponding to a read action on a resource. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. Any additional options will be passed to the underlying call to Ash.Query.for_read/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called. Keep in mind that the source of the form in this case is a query, not a changeset. This means that, very likely, you would not want to use nested forms here. However, it could make sense if you had a query argument that was an embedded resource, so the capability remains. Nested Form Options :type - The cardinality of the nested form. The default value is :single . :sparse? ( boolean/0 ) - If the nested form is sparse , the form won't expect all inputs for all forms to be present. Has no effect if the type is :single . Normally, if you leave some forms out of a list of nested forms, they are removed from the parameters passed to the action. For example, if you had a post with two comments [%Comment{id: 1}, %Comment{id: 2}] and you passed down params like comments[0][id]=1&amp;comments[1][text]=new_text , we would remove the second comment from the input parameters, resulting in the following being passed into the action: %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}]} . By setting it to sparse, you have to explicitly use remove_form for that removal to happen. So in the same scenario above, the parameters that would be sent would actually be %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}, %{&quot;id&quot; =&gt; 2}]} . One major difference with sparse? is that the form actually ignores the index provided, e.g comments[0]... , and instead uses the primary key e.g comments[0][id] to match which form is being updated. This prevents you from having to find the index of the specific item you want to update. Which could be very gnarly on deeply nested forms. If there is no primary key, or the primary key does not match anything, it is treated as a new form. REMEMBER: You need to use hidden_inputs_for (or HiddenInputs if using surface) for the id to be automatically placed into the form. :forms ( keyword/0 ) - Forms nested inside the current nesting level in all cases :for_type - What action types the form applies for. Leave blank for it to apply to all action types. :merge? ( boolean/0 ) - When building parameters, this input will be merged with its parent input. This allows for combining multiple forms into a single input. The default value is false . :for ( atom/0 ) - When creating parameters for the action, the key that the forms should be gathered into. Defaults to the key used to configure the nested form. Ignored if merge? is true . :resource ( atom/0 ) - The resource of the nested forms. Unnecessary if you are providing the data key, and not adding additional forms to this path. :create_action ( atom/0 ) - The create action to use when building new forms. Only necessary if you want to use add_form/3 with this path. :update_action ( atom/0 ) - The update action to use when building forms for data. Only necessary if you supply the data key. :data ( term/0 ) - The current value or values that should have update forms built by default. You can also provide a single argument function that will return the data based on the data of the parent form. This is important for multiple nesting levels of :list type forms, because the data depends on which parent is being rendered.","ref":"AshPhoenix.Form.html#for_read/3","title":"AshPhoenix.Form.for_read/3","type":"function"},{"doc":"Creates a form corresponding to an update action on a record. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. Any additional options will be passed to the underlying call to Ash.Changeset.for_update/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_update/3","title":"AshPhoenix.Form.for_update/3","type":"function"},{"doc":"Gets the form at the specified path","ref":"AshPhoenix.Form.html#get_form/2","title":"AshPhoenix.Form.get_form/2","type":"function"},{"doc":"Returns true if a given form path exists in the form","ref":"AshPhoenix.Form.html#has_form?/2","title":"AshPhoenix.Form.has_form?/2","type":"function"},{"doc":"Returns the hidden fields for a form as a keyword list","ref":"AshPhoenix.Form.html#hidden_fields/1","title":"AshPhoenix.Form.hidden_fields/1","type":"function"},{"doc":"Toggles the form to be ignored or not ignored. To set this manually in an html form, use the field :_ignored and set it to the string &quot;true&quot;. Any other value will not result in the form being ignored.","ref":"AshPhoenix.Form.html#ignore/1","title":"AshPhoenix.Form.ignore/1","type":"function"},{"doc":"Returns true if the form is ignored","ref":"AshPhoenix.Form.html#ignored?/1","title":"AshPhoenix.Form.ignored?/1","type":"function"},{"doc":"Merge the new options with the saved options on a form. See update_options/2 for more.","ref":"AshPhoenix.Form.html#merge_options/2","title":"AshPhoenix.Form.merge_options/2","type":"function"},{"doc":"Returns the parameters from the form that would be submitted to the action. This can be useful if you want to get the parameters and manipulate them/build a custom changeset afterwards.","ref":"AshPhoenix.Form.html#params/2","title":"AshPhoenix.Form.params/2","type":"function"},{"doc":"A utility for parsing paths of nested forms in query encoded format. For example: parse_path! ( form , &quot; post [ comments ] [ 0 ] [ sub_comments ] [ 0 ] ) [ :comments , 0 , :sub_comments , 0 ]","ref":"AshPhoenix.Form.html#parse_path!/2","title":"AshPhoenix.Form.parse_path!/2","type":"function"},{"doc":"Removes a form at the provided path. See add_form/3 for more information on the path argument. If you are not using liveview, and you want to support removing forms that were created based on the data option from the browser, you'll need to include in the form submission a custom list of strings to remove, and then manually iterate over them in your controller, for example: Enum . reduce ( removed_form_paths , form , &amp; AshPhoenix.Form . remove_form ( &amp;2 , &amp;1 ) ) :validate? ( boolean/0 ) - Validates the new full form. The default value is true . :validate_opts ( term/0 ) - Options to pass to validate . Only used if validate? is set to true (the default) The default value is [] .","ref":"AshPhoenix.Form.html#remove_form/3","title":"AshPhoenix.Form.remove_form/3","type":"function"},{"doc":"Sets the data of the form, in addition to the data of the underlying source, if applicable. Queries do not track data (because that wouldn't make sense), so this will not update the data for read actions","ref":"AshPhoenix.Form.html#set_data/2","title":"AshPhoenix.Form.set_data/2","type":"function"},{"doc":"Same as submit/2 , but raises an error if the submission fails.","ref":"AshPhoenix.Form.html#submit!/2","title":"AshPhoenix.Form.submit!/2","type":"function"},{"doc":"Submits the form by calling the appropriate function on the configured api. For example, a form created with for_update/3 will call api.update(changeset) , where changeset is the result of passing the Form.params/3 into Ash.Changeset.for_update/4 . If the submission returns an error, the resulting form can simply be rerendered. Any nested errors will be passed down to the corresponding form for that input. Options: :force? ( boolean/0 ) - Submit the form even if it is invalid in its current state. The default value is false . :api_opts ( keyword/0 ) - Opts to pass to the call to the api when submitting The default value is [] . :errors ( boolean/0 ) - Wether or not to show errors after submitting. The default value is true . :override_params ( term/0 ) - If specified, then the params are not extracted from the form. How this different from params : providing params is simply results in calling validate(form, params) before proceeding. The values that are passed into the action are then extracted from the form using params/2 . With override_params , the form is not validated again, and the override_params are passed directly into the action. :params ( term/0 ) - If specified, validate/3 is called with the new params before submitting the form. This is a shortcut to avoid needing to explicitly validate before every submit. For example: form |&gt; AshPhoenix.Form . validate ( params ) |&gt; AshPhoenix.Form . submit ( ) Is the same as: form |&gt; AshPhoenix.Form . submit ( params : params ) :read_one? ( boolean/0 ) - If submitting a read form, a single result will be returned (via read_one) instead of a list of results. Ignored for non-read forms. The default value is false . :before_submit (function of arity 1) - A function to apply to the source (changeset or query) just before submitting the action. Must return the modified changeset.","ref":"AshPhoenix.Form.html#submit/2","title":"AshPhoenix.Form.submit/2","type":"function"},{"doc":"Mark a field or fields as touched To mark nested fields as touched use with update_form/4 or update_forms_at_path/4","ref":"AshPhoenix.Form.html#touch/2","title":"AshPhoenix.Form.touch/2","type":"function"},{"doc":"Updates the form at the provided path using the given function. Marks all forms along the path as touched by default. To prevent it, provide mark_as_touched?: false . This can be useful if you have a button that should modify a nested form in some way, for example.","ref":"AshPhoenix.Form.html#update_form/4","title":"AshPhoenix.Form.update_form/4","type":"function"},{"doc":"Updates the list of forms matching a given path. Does not validate that the path points at a single form like update_form/4 . Additionally, if it gets to a list of child forms and the next part of the path is not an integer, it will update all of the forms at that path.","ref":"AshPhoenix.Form.html#update_forms_at_path/4","title":"AshPhoenix.Form.update_forms_at_path/4","type":"function"},{"doc":"Update the saved options on a form. When a form is created, options like actor and authorize? are stored in the opts key. If you have a case where these options change over time, for example a select box that determines the actor, use this function to override those opts. You may want to validate again after this has been changed if it can change the results of your form validation.","ref":"AshPhoenix.Form.html#update_options/2","title":"AshPhoenix.Form.update_options/2","type":"function"},{"doc":"Validates the parameters against the form. Options: :errors ( boolean/0 ) - Set to false to hide errors after validation The default value is true .","ref":"AshPhoenix.Form.html#validate/3","title":"AshPhoenix.Form.validate/3","type":"function"},{"doc":"Gets the value for a given field in the form.","ref":"AshPhoenix.Form.html#value/2","title":"AshPhoenix.Form.value/2","type":"function"},{"doc":"","ref":"AshPhoenix.Form.html#t:t/0","title":"AshPhoenix.Form.t/0","type":"type"},{"doc":"A tool to automatically generate available nested forms based on a resource and action. To use this, specify forms: [auto?: true] when creating the form. Keep in mind, you can always specify these manually when creating a form by simply specifying the forms option. There are two things that this builds forms for: Attributes/arguments who's type is an embedded resource. Arguments that have a corresponding change manage_relationship(..) configured. For more on relationships see the documentation for Ash.Changeset.manage_relationship/4 . When building forms, you can switch on the action type and/or resource of the form, in order to have different fields depending on the form. For example, if you have a simple relationship called :comments with on_match: :update and on_no_match: :create , there are two types of forms that can be in inputs_for(form, :comments) . In which case you may have something like this: &lt; % = for comment_form &lt;- inputs_for ( f , :comments ) do % &gt; &lt; % = hidden_inputs_for ( comment_form ) % &gt; &lt; % = if comment_form . source . type == :create do % &gt; &lt; % = text_input comment_form , :text % &gt; &lt; % = text_input comment_form , :on_create_field % &gt; &lt; % else % &gt; &lt; % = text_input comment_form , :text % &gt; &lt; % = text_input comment_form , :on_update_field % &gt; &lt; % end % &gt; &lt; button phx - click = &quot;remove_form&quot; phx - value - path = &quot;&lt;%= comment_form.name %&gt;&quot; &gt; Add Comment &lt; / button &gt; &lt; button phx - click = &quot;add_form&quot; phx - value - path = &quot;&lt;%= comment_form.name %&gt;&quot; &gt; Add Comment &lt; / button &gt; &lt; % end % &gt; This also applies to adding forms of different types manually. For instance, if you had a &quot;search&quot; field to allow them to search for a record (e.g in a liveview), and you had an on_lookup read action, you could render a search form for that read action, and once they've selected a record, you could render the fields to update that record (in the case of on_lookup: :relate_and_update configurations). Special Considerations on_lookup: :relate_and_update For on_lookup: :relate_and_update configurations, the &quot;read&quot; form for that relationship will use the appropriate read action. However, you may also want to include the relevant fields for the update that would subsequently occur. To that end, a special nested form called :_update is created, that uses an empty instance of that resource as the base of its changeset. This may require some manual manipulation of that data before rendering the relevant form because it assumes all the default values. To solve for this, if you are using liveview, you could actually look up the record using the input from the read action, and then use AshPhoenix.Form.update_form/3 to set that looked up record as the data of the _update form. Many to Many Relationships In the case that a manage_change option points to a join relationship, that form is presented via a special nested form called _join . So the first form in inputs_for(form, :relationship) would be for the destination, and then inside of that you could say inputs_for(nested_form, :_join) . The parameters are merged together during submission.","ref":"AshPhoenix.Form.Auto.html","title":"AshPhoenix.Form.Auto","type":"module"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#auto/3","title":"AshPhoenix.Form.Auto.auto/3","type":"function"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#embedded/3","title":"AshPhoenix.Form.Auto.embedded/3","type":"function"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#related/3","title":"AshPhoenix.Form.Auto.related/3","type":"function"},{"doc":"A protocol for allowing errors to be rendered into a form. To implement, define a to_form_error/1 and return a single error or list of errors of the following shape: {:field_name, message, replacements} Replacements is a keyword list to allow for translations, by extracting out the constants like numbers from the message.","ref":"AshPhoenix.FormData.Error.html","title":"AshPhoenix.FormData.Error","type":"protocol"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#to_form_error/1","title":"AshPhoenix.FormData.Error.to_form_error/1","type":"function"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#t:t/0","title":"AshPhoenix.FormData.Error.t/0","type":"type"},{"doc":"Utilities for keeping ash query results up to date in a live view.","ref":"AshPhoenix.LiveView.html","title":"AshPhoenix.LiveView","type":"module"},{"doc":"","ref":"AshPhoenix.LiveView.html#can_link_to_page?/2","title":"AshPhoenix.LiveView.can_link_to_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#change_page/3","title":"AshPhoenix.LiveView.change_page/3","type":"function"},{"doc":"Incorporates an Ash.Notifier.Notification into the query results, based on the liveness configuration. You will want to match on receiving a notification from Ash, and the easiest way to do that is to match on the payload like so: @impl true def handle_info ( %{ topic : topic , payload : % Ash.Notifier.Notification { } } , socket ) do { :noreply , handle_live ( socket , topic , [ :query1 , :query2 , :query3 ] ) } end Feel free to intercept notifications and do your own logic to respond to events. Ultimately, all that matters is that you also call handle_live/3 if you want it to update your query results. The assign or list of assigns passed as the third argument must be the same names passed into keep_live . If you only want some queries to update based on some events, you can define multiple matches on events, and only call handle_live/3 with the assigns that should be updated for that notification.","ref":"AshPhoenix.LiveView.html#handle_live/4","title":"AshPhoenix.LiveView.handle_live/4","type":"function"},{"doc":"Runs the callback, and stores the information required to keep it live in the socket assigns. The data will be assigned to the provided key, e.g keep_live(socket, :me, ...) would assign the results to :me (accessed as @me in the template). Additionally, you'll need to define a handle_info/2 callback for your liveview to receive any notifications, and pass that notification into handle_live/3 . See handle_live/3 for more. Important The logic for handling events to keep data live is currently very limited. It will simply rerun the query every time. To this end, you should feel free to intercept individual events and handle them yourself for more optimized liveness. Pagination To make paginated views convenient, as well as making it possible to keep those views live, Ash does not simply rerun the query when it gets an update, as that could involve shuffling the records around on the page. Eventually this will be configurable, but for now, Ash simply adjusts the query to only include the records that are on the page. If a record would be removed from a page due to a data change, it will simply be left there. For the best performance, use keyset pagination. If you need the ability to jump to a page by number, you'll want to use offset pagination, but keep in mind that it performs worse on large tables. To support this, accept a second parameter to your callback function, which will be the options to use in page_opts Options: :subscribe - A topic or list of topics that should cause this data to update. :refetch? ( boolean/0 ) - A boolean flag indicating whether a refetch is allowed to happen. Defaults to true :after_fetch ( term/0 ) - A two argument function that takes the results, and the socket, and returns the new socket. Can be used to set assigns based on the result of the query. :results - For list and page queries, by default the records shown are never changed (unless the page changes) The default value is :keep . :load_until_connected? ( boolean/0 ) - If the socket is not connected, then the value of the provided assign is set to :loading . Has no effect if initial is provided. :initial ( term/0 ) - Results to use instead of running the query immediately. :api ( atom/0 ) - For paginated views, in order to use change_page/3 , you must set the Api to use for pagination :refetch_interval ( non_neg_integer/0 ) - An interval (in ms) to periodically refetch the query :refetch_window ( non_neg_integer/0 ) - The minimum time (in ms) between refetches, including refetches caused by notifications. A great way to get readable millisecond values is to use the functions in erlang's :timer module, like :timer.hours/1 , :timer.minutes/1 , and :timer.seconds/1 refetch_interval If this option is set, a message is sent as {:refetch, assign_name, opts} on that interval. You can then match on that event, like so: def handle_info ( { :refetch , assign , opts } , socket ) do { :noreply , handle_live ( socket , :refetch , assign , opts ) } end This is the equivalent of :timer.send_interval(interval, {:refetch, assign, opts}) , so feel free to roll your own solution if you have complex refetching requirements. refetch_window Normally, when a pubsub message is received the query is rerun. This option will cause the query to wait at least this amount of time before doing a refetch. This is accomplished with Process.send_after/4 , and recording the last time each query was refetched. For example if a refetch happens at time 0 , and the refetch_window is 10,000 ms, we would refetch, and record the time. Then if another refetch should happen 5,000 ms later, we would look and see that we need to wait another 5,000ms. So we use Process.send_after/4 to send a {:refetch, assign, opts} message in 5,000ms. The time that a refetch was requested is tracked, so if the data has since been refetched, it won't be refetched again. Future Plans One interesting thing here is that, given that we know the scope of data that a resource cares about, we should be able to make optimizations to this code, to support partial refetches, or even just updating the data directly. However, this will need to be carefully considered, as the risks involve showing users data they could be unauthorized to see, or having state in the socket that is inconsistent.","ref":"AshPhoenix.LiveView.html#keep_live/4","title":"AshPhoenix.LiveView.keep_live/4","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#last_page/1","title":"AshPhoenix.LiveView.last_page/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#next_page?/1","title":"AshPhoenix.LiveView.next_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#on_page?/2","title":"AshPhoenix.LiveView.on_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_from_params/3","title":"AshPhoenix.LiveView.page_from_params/3","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_link_params/2","title":"AshPhoenix.LiveView.page_link_params/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_number/1","title":"AshPhoenix.LiveView.page_number/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_params/1","title":"AshPhoenix.LiveView.page_params/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#prev_page?/1","title":"AshPhoenix.LiveView.prev_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assign/0","title":"AshPhoenix.LiveView.assign/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assigns/0","title":"AshPhoenix.LiveView.assigns/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback/0","title":"AshPhoenix.LiveView.callback/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback_result/0","title":"AshPhoenix.LiveView.callback_result/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:liveness_options/0","title":"AshPhoenix.LiveView.liveness_options/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:socket/0","title":"AshPhoenix.LiveView.socket/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:topic/0","title":"AshPhoenix.LiveView.topic/0","type":"type"},{"doc":"This is a basic plug that loads the current tenant assign from a given value set on subdomain. This was copied from Triplex.SubdomainPlug , here: https://github.com/ateliware/triplex/blob/master/lib/triplex/plugs/subdomain_plug.ex Options: :endpoint ( atom/0 ) - Required. The endpoint that the plug is in, used for deterining the host :assign ( atom/0 ) - The key to use when assigning the current tenant The default value is :current_tenant . :handle_subdomain - An mfa to call with the conn and a subdomain value. Can be used to do something like fetch the current user given the tenant. Must return the new conn. To plug it on your router, you can use: plug Ash.SubdomainPlug , endpoint : MyApp.Endpoint An additional helper here can be used for determining the host in your liveview, and/or using the host that was already assigned to the conn. For example: def handle_params ( params , uri , socket ) do socket = assign_new ( socket , :current_tenant , fn -&gt; AshPhoenix.SubdomainPlug . live_tenant ( socket , uri ) end ) socket = assign_new ( socket , :current_organization , fn -&gt; if socket . assigns [ :current_tenant ] do MyApp.Accounts.Api . get! ( MyApp.Accounts.Organization , subdomain : socket . assigns [ :current_tenant ] ) end end ) { :noreply , socket } end","ref":"AshPhoenix.SubdomainPlug.html","title":"AshPhoenix.SubdomainPlug","type":"module"},{"doc":"","ref":"AshPhoenix.SubdomainPlug.html#live_tenant/2","title":"AshPhoenix.SubdomainPlug.live_tenant/2","type":"function"},{"doc":"Raised when an invalid path is used to find, update or remove a form","ref":"AshPhoenix.Form.InvalidPath.html","title":"AshPhoenix.Form.InvalidPath","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.InvalidPath.html#message/1","title":"AshPhoenix.Form.InvalidPath.message/1","type":"function"},{"doc":"Raised when a form action should happen but no action of the appropriate type has been configured","ref":"AshPhoenix.Form.NoActionConfigured.html","title":"AshPhoenix.Form.NoActionConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoActionConfigured.html#message/1","title":"AshPhoenix.Form.NoActionConfigured.message/1","type":"function"},{"doc":"Raised when a data needed to be used but the required data was not loaded","ref":"AshPhoenix.Form.NoDataLoaded.html","title":"AshPhoenix.Form.NoDataLoaded","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoDataLoaded.html#message/1","title":"AshPhoenix.Form.NoDataLoaded.message/1","type":"function"},{"doc":"Raised when attempting to refer to a form but no nested form with that name was configured.","ref":"AshPhoenix.Form.NoFormConfigured.html","title":"AshPhoenix.Form.NoFormConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoFormConfigured.html#message/1","title":"AshPhoenix.Form.NoFormConfigured.message/1","type":"function"},{"doc":"Raised when a form needed to be constructed but the resource for that form could not be determined","ref":"AshPhoenix.Form.NoResourceConfigured.html","title":"AshPhoenix.Form.NoResourceConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoResourceConfigured.html#message/1","title":"AshPhoenix.Form.NoResourceConfigured.message/1","type":"function"},{"doc":"The AshPhoenix plugin adds lots of helpers for working with Phoenix Liveview (and regular views). {:ash_phoenix, &quot;~&gt; 1.2.4&quot;}","ref":"working-with-phoenix.html","title":"Working With Phoenix","type":"extras"},{"doc":"AshPhoenix.Form - A form data structure for using resource actions with phoenix forms AshPhoenix.Form.Auto - Tools to automatically determine nested form structures based on calls manage_relationship for an action. AshPhoenix.FilterForm - A form data structure for building filter statements AshPhoenix.LiveView - Helpers for querying data and integrating changes AshPhoenix.SubdomainPlug - A plug to determine a tenant using subdomains for multitenancy AshPhoenix.FormData.Error - A protocol to allow errors to be rendered in forms Phoenix.HTML.Safe implementations for Ash.CiString and Ash.NotLoaded","ref":"working-with-phoenix.html#whats-in-the-box","title":"Working With Phoenix - Whats in the box?","type":"extras"}]